/*
 **************************************************************************
 *		SWI-Prolog ActiveX Extensions.
 *
 *	This software is provided in source and binary form free of charge to 
 *  users of SWI-Prolog.  No warranty of any kind is expressed or implied;
 *  in particular, this is entirely unsupported software.
 *
 *  Documentation for this product is available from the SWI-Prolog 
 *  web site (http://www.swi.psy.uva.nl/projects/SWI-Prolog/).
 *
 *	Version 1.0.1.
 *
 *	October 1, 1999
 *
 **************************************************************************
 */

//
//	plcvt.h
//
#pragma once

#include <SWI-Prolog.h>
#include <stdio.h>
#include <stdlib.h>
#include <map>
#include "declcom.h"
#include "basics.h"
#include "zstr.h"


typedef vector<LONG> VLONG;


//  Define IP_IDispatch
DECL_IP_U(IDispatch,IID_IDispatch);



//
//	Class Id and guid conversion functions
//
extern bool bStringFromGuid ( const GUID & guid, ZSTR & zsGuid );
extern bool bGuidFromString ( TSZC tszcGuid, GUID & guid );
extern bool bGetClsId ( TSZC tszcProgId, CLSID & clsid );
extern bool bGetClsIdString ( TSZC tszcProgId, ZSTR & zsClsId );

//	
//	VARIANT <-> Prolog term conversions
//
bool bConvertVariantToInt ( _variant_t & vnt, int & iResult );
bool bPrepareList ( term_t tList, VARTYPE & vt, int & citems );
bool bConvertListToVariant ( term_t tList, _variant_t & vnt );


bool bConvertListToVariantSafearray ( 
	term_t tList,						//  The list head
	_variant_t & vnt,					//	The resulting variant containing the SAFEARRAY
	VARTYPE vt = VT_EMPTY );			//	The desired VARTYPE; VT_EMPTY implies "guess"
